package api.common.pojo.dto;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * {
 *  "projectId": "sadfasdfs", // 项目 id
 *  "algorithmId": "sadfasdfs", // 算法 id
 *  "vehicleId": "sadfasdfs", // 车辆 id
 *  "scenePackageId": "sadfasdfs", // 场景包 id
 *  "maxSimulationTime": 11111, // 最大仿真时间
 *  "parallelism": 30  // 并行度
 *  "type": 30  // 项目类型
 * }
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ProjectMessageDTO {

    private String projectId;// 项目 id
    private String algorithmId;// 算法 id
    private String vehicleConfigId;// 车辆配置 id
    private String scenePackageId;// 场景包 id
    private Integer maxSimulationTime;// 最大仿真时间（秒）
    private Integer parallelism;// 期望并行度，页面上创建项目时指定的并行度
    private String type;// 项目类型
    // -------------------------------- Comment --------------------------------
    private Integer currentParallelism;// 当前正在使用的并行度
    private Integer taskTotal;// 任务总数量
    private Integer taskCompleted;// 任务已完成数量

}
