package api.common.pojo.po.scene;

import lombok.*;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * 测试场景包
 */
@EqualsAndHashCode()
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ScenePackagePO implements Serializable {

    private String packageId  ;//主键Id
    private String packageCode  ;//测试包指标Id
    private String packageName ; //指标名称
    private String weight;//权重
    private String rulesName ; //规则名称
    private String packageAndRules;//关联打分规则Id
    private Integer sceneNum;//场景数量
    private String remarks;//备注
    private String share ; //是否分析  1为分享
    private String treeNode;//模板预览node节点
    /**
     * 记录创建时间
     */
    public Timestamp createTime;
    /**
     * 记录最后更新时间（包括删除）
     */
    public Timestamp modifyTime;
    /**
     * 记录创建人（用户id）
     */
    public String createUserId;
    /**
     * 记录最后更新人（包括删除）（用户id）
     */
    public String modifyUserId;
    /**
     * 是否已删除
     */
    public String isDeleted;












}