package api.common.util;

import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.api.errors.GitAPIException;
import org.eclipse.jgit.lib.Ref;
import org.eclipse.jgit.transport.UsernamePasswordCredentialsProvider;

import java.io.*;
import java.security.KeyManagementException;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.util.Map;



/**
 <dependency>
 <groupId>org.eclipse.jgit</groupId>
 <artifactId>org.eclipse.jgit</artifactId>
 </dependency>
 */
public class JgitUtil {


    public static Map<String, Ref> testConnection(String remoteUrl, String username, String password) throws GitAPIException {
       UsernamePasswordCredentialsProvider provider = new UsernamePasswordCredentialsProvider(username,password);
       Map<String, Ref> asMap = Git.lsRemoteRepository().setRemote(remoteUrl).setCredentialsProvider(provider).callAsMap();
       return asMap;
    }

    public static Map<String, Ref> testConnectionByToken(String remoteUrl, String gitToken) throws GitAPIException {
        UsernamePasswordCredentialsProvider provider = new UsernamePasswordCredentialsProvider("PRIVATE-TOKEN", gitToken);
        Map<String, Ref> asMap = Git.lsRemoteRepository().setRemote(remoteUrl).setCredentialsProvider(provider).callAsMap();
        return asMap;
    }

    public static Git clone(String remoteUrl, String directory, String username, String password) throws GitAPIException, IOException {
        UsernamePasswordCredentialsProvider provider = new UsernamePasswordCredentialsProvider(username,password);
        File localPath = new File(directory);
        Git result = Git.cloneRepository().setURI(remoteUrl).setDirectory(localPath).setCredentialsProvider(provider).call();
        return result;
    }


    public static void main(String[] args) throws GitAPIException, IOException, NoSuchAlgorithmException, KeyStoreException, KeyManagementException {
       try {
           Git git = clone("https://github.com/tensorflow/serving.git","E:\\simulation-cloud\\test","","");
//           Iterable<RevCommit> iterable = git.log().call();
//           for (RevCommit u : iterable) {
//               String ID = String.valueOf(u.getId());
//               System.out.println("cgfghdnhg");
//               System.out.println(u.getFullMessage());
//               System.out.println( ID);
//               System.out.println("done!!");
////               正则表达式 截取需要的部分
////               versionID = getMatcher("commit\\s(\\w+)\\s?", ID);
//               break;
//           }
           System.out.println("slfasjkfasfksd:");
           System.out.println(git.log());
       }catch (Exception e){
           System.out.println("failllll:");
       }
    }




}
