package com.css.simulation.resource.scene.common.utils;

import com.css.simulation.resource.scene.common.oauth.MyUserDetails;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

/**
 * 认证信息工具类
 */
public class AuthUtil {

    /**
     * 获取当前登录人id
     */
    public static String getCurrentUserId(){
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails)authentication.getPrincipal();
        String userId = userDetails.getId();
        return userId;
    }

    /**
     * 获取当前登录人roleCode
     */
    public static String getCurrentUserRoleCode(){
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails)authentication.getPrincipal();
        String roleCode = userDetails.getRoleCode();
        return roleCode;
    }

    /**
     * 获取当前登录人useType
     */
    public static String getCurrentUseType(){
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails)authentication.getPrincipal();
        String useType = userDetails.getUseType();
        return useType;
    }

    /**
     * 获取当前登录人username
     */
    public static String getCurrentUsername(){
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails)authentication.getPrincipal();
        String username = userDetails.getUsername();
        return username;
    }

    /**
     * 获取当前登录人createUserId
     */
    public static String getCreateUserId(){
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails)authentication.getPrincipal();
        String createUserId = userDetails.getCreateUserId();
        return createUserId;
    }

}
