package com.css.simulation.resource.scheduler.util;

import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.eclipse.jgit.api.Git;
import org.eclipse.jgit.transport.UsernamePasswordCredentialsProvider;

import java.io.File;

/**
 * <!-- git 操作类库 -->
 * <dependency>
 * <groupId>org.eclipse.jgit</groupId>
 * <artifactId>org.eclipse.jgit</artifactId>
 * <version>${org.eclipse.jgit.version}</version>
 * </dependency>
 */
@Slf4j
public class GitUtil {

    /**
     * @param url                 git 地址
     * @param username            用户名
     * @param password            密码
     * @param localEmptyDirectory 空目录
     */
    @SneakyThrows
    public static void clone(String url, String username, String password, String localEmptyDirectory) {
        File localEmptyDirectoryFile = new File(localEmptyDirectory);
        if (localEmptyDirectoryFile.exists()) {
            File[] files = localEmptyDirectoryFile.listFiles();
            if (files == null || files.length > 0) {
                throw new RuntimeException("GitUtil--clone 目标下载目录不是空目录。");
            }
        } else {
            localEmptyDirectoryFile.mkdirs();
        }
        Git git = Git.cloneRepository()
                .setURI(url)
                .setCredentialsProvider(new UsernamePasswordCredentialsProvider(username, password))
                .setDirectory(localEmptyDirectoryFile)
                .call();
    }
}
