package com.css.simulation.resource.common.utils;

import com.css.simulation.resource.common.oauth.MyUserDetails;
import lombok.extern.slf4j.Slf4j;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

/**
 * 认证信息工具类
 */
@Slf4j
public class AuthUtil {

    /**
     * 获取当前登录人id
     */
    public static String getCurrentUserId() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails) authentication.getPrincipal();
        String userId = userDetails.getId();
        log.info("AuthUtil--getCurrentUserId 当前用户的 userId 为：" + userId);
        return userId;
    }

    /**
     * 获取当前登录人roleCode
     */
    public static String getCurrentUserRoleCode() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails) authentication.getPrincipal();
        String roleCode = userDetails.getRoleCode();
        log.info("AuthUtil--getCurrentUserId 当前用户的 roleCode 为：" + roleCode);
        return roleCode;
    }

    /**
     * 获取当前登录人useType
     */
    public static String getCurrentUseType() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails) authentication.getPrincipal();
        String useType = userDetails.getUseType();
        log.info("AuthUtil--getCurrentUserId 当前用户的 useType 为：" + useType);
        return useType;
    }

    /**
     * 获取当前登录人username
     */
    public static String getCurrentUsername() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails) authentication.getPrincipal();
        String username = userDetails.getUsername();
        log.info("AuthUtil--getCurrentUserId 当前用户的 username 为：" + username);
        return username;
    }

    /**
     * 获取当前登录人createUserId
     */
    public static String getCreateUserId() {
        Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
        MyUserDetails userDetails = (MyUserDetails) authentication.getPrincipal();
        String createUserId = userDetails.getCreateUserId();
        log.info("AuthUtil--getCurrentUserId 当前用户的 createUserId 为：" + createUserId);
        return createUserId;
    }

}
