package com.css.simulation.resource.feign;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.project.SimulationManualProjectParam;
import com.css.simulation.resource.common.config.FeignConfiguration;
import com.css.simulation.resource.feign.fallback.MonitorServiceFallback;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.List;

@FeignClient(
        //name = "MonitorService",
        //url = "http://127.0.0.1:7004",
        contextId = "MonitorService",
        value = "simulation-resource-monitor",
        path = "/simulation/resource/monitor",
        fallback = MonitorServiceFallback.class,
        configuration = FeignConfiguration.class)
public interface MonitorService {

    @PostMapping("/projectTask/init")
    ResponseBodyVO<Integer> init(List<SimulationManualProjectParam> list);

    @PostMapping("/projectTask/start")
    ResponseBodyVO start(SimulationManualProjectParam param);

    @PostMapping("/projectTask/stop")
    ResponseBodyVO stop(SimulationManualProjectParam param);



}