package com.css.simulation.resource.open.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.param.project.SimulationManualProjectParam;
import api.common.util.ObjectUtil;
import com.css.simulation.resource.project.service.SimulationProjectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.Calendar;
import java.util.Map;

@Controller
@RequestMapping("/monitor")
public class MonitorCtrl {

    @Autowired
    private SimulationProjectService service;

    /**
     * 运行自动任务
     */
    @RequestMapping("createAutomaticSubProject")
    @ResponseBody
    public ResponseBodyVO createAutomaticSubProject(@RequestBody Map<String,String> paramMap){

        if(ObjectUtil.isNull(paramMap) || ObjectUtil.isNull(paramMap.get("id"))){
            return new ResponseBodyVO(false, 500, "参数必传！",null);
        }

        SimulationManualProjectParam param = new SimulationManualProjectParam();
        param.setId(paramMap.get("id"));

        System.out.println("运行自动任务:"+ Calendar.getInstance().getTime()+"/"+paramMap.get("id"));

        //return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);

        return service.createAutomaticSubProject(param);

    }

}
