package com.css.simulation.resource.scene.ctrl;

import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.constants.DictConstants;
import api.common.pojo.param.scene.SceneImportParam;
import api.common.pojo.param.scene.SceneNaturalNewParam;
import api.common.pojo.param.scene.SceneNaturalParam;
import api.common.pojo.po.scene.SceneNaturalPO;
import api.common.pojo.po.system.SceneImportPO;
import api.common.pojo.vo.scene.SceneNaturalVO;
import api.common.util.ObjectUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.scene.service.SceneNaturalService;
import com.css.simulation.resource.system.service.SceneImportService;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.BeanUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

//自然场景
@RestController
@RequestMapping("/SceneNatural")
public class SceneNaturalController {

    @Resource
    SceneNaturalService sceneNaturalService;
    @Resource
    SceneImportService sceneImportService;

    //查询列表
    @PostMapping("/querySceneNaturalList")
    @ResponseBody
    public ResponseBodyVO<List<SceneNaturalVO>> querySceneNaturalList(@RequestBody SceneNaturalNewParam params) {
        PageUtil.setPageInfo(params);
        List<SceneNaturalPO> list = sceneNaturalService.querySceneNaturalList(params);
        PageInfo<SceneNaturalPO> objectPageInfo = new PageInfo<>(list);
        List<SceneNaturalVO> list1 = new ArrayList<>();
        for (SceneNaturalPO po : list) {
            SceneNaturalVO vo = new SceneNaturalVO();
            BeanUtils.copyProperties(po, vo);
            list1.add(vo);
        }
        PageInfo pageInfo = new PageInfo<>(list1);
        pageInfo.setTotal(objectPageInfo.getTotal());
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, pageInfo);
    }


    //新增自然场景
    @PostMapping("/saveSceneNatural")
    @ResponseBody
    public ResponseBodyVO<String> saveSceneNatural(@RequestBody SceneNaturalParam params) {

        return sceneNaturalService.importZrjsSceneCicv(params);
    }

    //删除
    @PostMapping("/deleteSceneNatural")
    @ResponseBody
    public ResponseBodyVO<String> deleteSceneNatural(@RequestBody SceneNaturalPO params) {
        if (ObjectUtil.isNull(params.getNaturalId())) {
            return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE, "参数场景Id不能为空，请检查");
        }
        sceneNaturalService.deleteSceneNatural(params);
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }
    //批量导入
    @PostMapping("/saveSceneNaturalBatch")
    @ResponseBody
    public ResponseBodyVO<String> saveSceneNaturalBatch(@RequestBody SceneImportParam sceneImportParam) {
        SceneImportPO sceneImportPO=new  SceneImportPO();
        sceneImportPO.setId(sceneImportParam.getId());
        sceneImportPO.setStatus(DictConstants.SCENE_IMPORT_STATUS_3);
        sceneImportService.updateStatus(sceneImportPO);
        sceneImportPO= sceneNaturalService.importMiNio(sceneImportParam);
        sceneImportService.updateInfo(sceneImportPO);
       return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS);
    }

}