package com.css.simulation.resource.scene.service;


import api.common.pojo.common.ResponseBodyVO;
import api.common.pojo.po.scene.SceneGeneralDataPO;
import api.common.pojo.po.scene.SceneGeneralExamplePO;
import api.common.pojo.po.scene.SceneGeneralTemplatePO;
import api.common.pojo.vo.scene.SceneGeneralTemplateMbVO;
import api.common.pojo.vo.scene.SceneGeneralTemplateVO;
import api.common.util.*;
import com.css.simulation.resource.common.utils.AuthUtil;
import com.css.simulation.resource.scene.mapper.SceneGeneralDataMapper;
import com.css.simulation.resource.scene.mapper.SceneGeneralExampleMapper;
import com.css.simulation.resource.scene.mapper.SceneGeneralTemplateMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.apache.http.client.config.RequestConfig;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.io.File;
import java.io.FileInputStream;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.*;

@Slf4j
@Service
public class SceneGeneralExampleService {

    @Resource
    SceneGeneralExampleMapper exampleMapper;
    @Resource
    SceneGeneralTemplateMapper templateMapper;
    @Resource
    SceneGeneralDataMapper dataMapper;
    @Resource
    SceneGeneralTemplateService sceneGeneralTemplateService;

       @SneakyThrows
       public  ResponseBodyVO querySceneGeneralExampleById(String id) {

        SceneGeneralExamplePO examplePo= exampleMapper.querySceneGeneralExampleById(id);
        if(ObjectUtil.isNotNull(examplePo)){
            SceneGeneralTemplatePO templatePO=templateMapper.querySceneGeneralTemplateById(examplePo.getTemplateId());
            if(ObjectUtil.isNotNull(templatePO)&&templatePO.getIsDeleted().equals("1")){
                examplePo.setIsTure("1");
            }
        }
           String generalizationType =JsonUtil.stringToJson(examplePo.getGeneralizationType());
           examplePo.setGeneralizationType(generalizationType);

           //转换为vo
           SceneGeneralTemplatePO po=new SceneGeneralTemplatePO();
           BeanUtils.copyProperties(examplePo, po);
           SceneGeneralTemplateVO vo=new SceneGeneralTemplateVO();
           BeanUtils.copyProperties(po, vo);
           List<SceneGeneralTemplateMbVO>  listMb=new ArrayList<>();
           if(po.getObsStartX().indexOf(";")!=-1){
               listMb= sceneGeneralTemplateService.spliceVo(po);
           }else{
               SceneGeneralTemplateMbVO  mbVO=new SceneGeneralTemplateMbVO();
               BeanUtils.copyProperties(po, mbVO);
               mbVO.setGeneralizationType(po.getGeneralizationType());
               listMb.add(mbVO);
           }
           vo.setListMb(listMb);
           vo.setTemplateId(examplePo.getTemplateId());
           vo.setIsTure(examplePo.getIsTure());


        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, vo);

    }

    public  ResponseBodyVO queryType() {

        List<String> list= templateMapper.queryType();

        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, list);

    }

    @SneakyThrows
    public  ResponseBodyVO saveSceneGeneralExample(SceneGeneralTemplateVO vo) {
   /*        //测试用
        SceneGeneralTemplatePO po1=templateMapper.querySceneGeneralTemplateById(vo.getTemplateId());
        BeanUtils.copyProperties(po1, vo);*/

        //查询泛化标志位并赋值
        SceneGeneralTemplatePO poV= templateMapper.querySceneGeneralTemplateById(vo.getTemplateId());
        SceneGeneralExamplePO po=new SceneGeneralExamplePO();
        //转换为vo
        BeanUtils.copyProperties(vo, po);
        po.setGeneralizationType(poV.getGeneralizationType());
        po.setEgoVelocityStatus(poV.getEgoVelocityStatus());
        po.setEgoTrajectory(poV.getEgoTrajectory());
        po.setObsVelocityStatus(poV.getObsVelocityStatus());
        po.setObsTrajectory(poV.getObsTrajectory());
        //加个唯一值，确定文件夹唯一
        po.setUuId(StringUtil.getRandomUUID());

        //合并目标物
        List<SceneGeneralTemplateMbVO> listMb=vo.getListMb();

        String  obsStartX= "";
        String  obsStartY="";;
        String  obsStartVelocity= "";
        String  obsLateralAcceleration="";
        String  obsLongitudinalAcceleration= "";
        String  obsHeadingAngleRel= "";
        String  obsDurationTime= "";
        String  obsVelocityTime= "";
        String  obsTrailTime= "";
        String  obsType= "";


        int a=0;
        for (SceneGeneralTemplateMbVO mbVo: listMb) {
            if(a<1){
                obsStartX=mbVo.getObsStartX();
                obsStartY=mbVo.getObsStartY();
                obsStartVelocity= mbVo.getObsStartVelocity();
                obsLateralAcceleration=mbVo.getObsLateralAcceleration();
                obsLongitudinalAcceleration=mbVo.getObsLongitudinalAcceleration();
                obsHeadingAngleRel= mbVo.getObsHeadingAngleRel();
                obsDurationTime= mbVo.getObsDurationTime();
                obsVelocityTime=mbVo.getObsVelocityTime();
                obsTrailTime=mbVo.getObsTrailTime();
                obsType=mbVo.getObsType();
            }else{
                obsStartX=obsStartX+";"+mbVo.getObsStartX();
                obsStartY=obsStartY+";"+mbVo.getObsStartY();
                obsStartVelocity=obsStartVelocity+";"+mbVo.getObsStartVelocity();
                obsLateralAcceleration=obsLateralAcceleration+";"+mbVo.getObsLateralAcceleration();
                obsLongitudinalAcceleration=obsLongitudinalAcceleration+";"+mbVo.getObsLongitudinalAcceleration();
                obsHeadingAngleRel=obsHeadingAngleRel +";"+mbVo.getObsHeadingAngleRel();
                obsDurationTime=obsDurationTime +";"+mbVo.getObsDurationTime();
                obsVelocityTime=obsVelocityTime+";"+mbVo.getObsVelocityTime();
                obsTrailTime=obsTrailTime+";"+mbVo.getObsTrailTime();
                obsType=obsType+";"+mbVo.getObsType();
            }
            a++;
        }

        po.setObsStartX(obsStartX);
        po.setObsStartY(obsStartY);
        po.setObsStartVelocity(obsStartVelocity);
        po.setObsLateralAcceleration(obsLateralAcceleration);
        po.setObsLongitudinalAcceleration(obsLongitudinalAcceleration);
        po.setObsHeadingAngleRel(obsHeadingAngleRel);
        po.setObsDurationTime(obsDurationTime);
        po.setObsVelocityTime(obsVelocityTime);
        po.setObsTrailTime(obsTrailTime);
        po.setObsType(obsType);
        //远程调用接口
        Map map=  beanToMap(po);
        RequestConfig requestConfig = RequestConfig.custom()
                .setSocketTimeout(6*10*1000)
                .setConnectTimeout(6*10*1000)
                .setConnectionRequestTimeout(6*10*1000)
                .setRedirectsEnabled(false)
                .setExpectContinueEnabled(false)
                .build();

        String post = HttpUtil.post(HttpUtil.getHttpClient(), requestConfig, "http://47.94.105.148:5000/test_1.0", null, map);
       Boolean success= JsonUtil.readTree(post).get("success").asBoolean();
       if(!success){
           String message= JsonUtil.readTree(post).get("message").toString();
           return new ResponseBodyVO(ResponseBodyVO.Response.CLIENT_FAILURE, message);
       }
        JsonNode params = JsonUtil.readTree(post).get("params");
        // 实例化 ObjectMapper 对象
        ObjectMapper objectMapper = new ObjectMapper();
        String newjson = objectMapper.writeValueAsString(params);
        List<SceneGeneralDataPO>  list=JsonUtil.jsonToList(newjson,SceneGeneralDataPO.class);

        String sceneGeneralizationIds=null;
        //生成指标id
        String sublistId=StringUtil.getRandomUUID();
        //生成实例主键id
        String exampleId=StringUtil.getRandomUUID();
        for (SceneGeneralDataPO datePo:list) {
            //生成主键id
            String dataId=StringUtil.getRandomUUID();
            datePo.setId(dataId);
            datePo.setCreateTime(TimeUtil.getNowForMysql());
            datePo.setCreateUserId(AuthUtil.getCurrentUserId());
            datePo.setModifyTime(TimeUtil.getNowForMysql());
            datePo.setIsDeleted("0");
            datePo.setSceneId(po.getSceneId());
            datePo.setTemplateId(po.getId());
            datePo.setExampleId(exampleId);
            datePo.setSublistId(sublistId);
            if(ObjectUtil.isNotNull(sceneGeneralizationIds)){
                sceneGeneralizationIds=  sceneGeneralizationIds+","+dataId;
            }else{
                sceneGeneralizationIds=dataId;
            }
        }
        dataMapper.saveSceneGeneralDataAll(list);
       // po.setTemplateId(po.getId());  //前端需要帮忙赋值
        po.setId(exampleId);
        po.setSublistId(sublistId);
        po.setCreateTime(TimeUtil.getNowForMysql());
        po.setSceneId(po.getSceneId());
        po.setCreateUserId(AuthUtil.getCurrentUserId());
        po.setModifyTime(TimeUtil.getNowForMysql());
        po.setIsDeleted("0");
        //po.setGeneralizationType(generalizationType);
        exampleMapper.saveSceneGeneralExample(po);
        Map map1=new HashMap();
        map1.put("exampleId",exampleId);//实例id
        map1.put("sceneNum",list.size());//场景数量
        map1.put("templateId",po.getTemplateId()); //模板id
        map1.put("sceneGeneralizationIds",sceneGeneralizationIds);//泛化场景数组
        map1.put("sublistId",sublistId); //指标id
        return new ResponseBodyVO(ResponseBodyVO.Response.SUCCESS, map1);

    }

    /**
     * 对象转Map
     * @param object
     * @return
     * @throws IllegalAccessException
     */
    public  Map beanToMap(Object object) throws IllegalAccessException {
        Map<String, Object> map = new HashMap<String, Object>();
        Field[] fields = object.getClass().getDeclaredFields();
        for (Field field : fields) {
            field.setAccessible(true);
            map.put(field.getName(), field.get(object));
        }
        return map;
    }

}
