package com.css.simulation.resource.util;

import api.common.pojo.constants.DictConstants;
import api.common.pojo.po.project.SchedulerProjectPO;
import com.css.simulation.resource.project.mapper.AutoSubProjectMapper;
import com.css.simulation.resource.project.mapper.ManualProjectMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class ProjectUtil {

    ManualProjectMapper manualProjectMapper;
    AutoSubProjectMapper autoSubProjectMapper;

    @Autowired
    public ProjectUtil(ManualProjectMapper manualProjectMapper, AutoSubProjectMapper autoSubProjectMapper) {
        this.manualProjectMapper = manualProjectMapper;
        this.autoSubProjectMapper = autoSubProjectMapper;
    }

    public String getProjectTypeByProjectId(String projectId) {
        String projectType = null;
        SchedulerProjectPO manualProjectPO = manualProjectMapper.selectById(projectId);
        SchedulerProjectPO autoSubProjectPO = autoSubProjectMapper.selectById(projectId);
        if (manualProjectPO != null) {
            projectType = DictConstants.PROJECT_TYPE_MANUAL;
        } else if (autoSubProjectPO != null) {
            projectType = DictConstants.PROJECT_TYPE_AUTO_SUB;
        }
        return projectType;
    }

    public static String getEvaluationLevelReport(double algorithmScore) {
        if (algorithmScore >= 90) {
            return DictConstants.REPORT_LEVEL_G;
        } else if (algorithmScore >= 80) {
            return DictConstants.REPORT_LEVEL_A;
        } else if (algorithmScore >= 70) {
            return DictConstants.REPORT_LEVEL_M;
        } else {
            return DictConstants.REPORT_LEVEL_P;
        }
    }
}
